#include <iostream>
#include <sstream>
#include <vector>
using namespace std;

const int row=3,col=2;

const int INVALID=-2;
const int LOWER=-1,HIGHER=1;
const int STGLEFT=2,STGOPER=3,STGRIGHT=4,STGENDING=5;

const char operTable[row][col]= {
//ַ 
	{'+','-'},
	{'*','/'},
	{'(',')'}
};

class node {
//õĽڵԪأв  Ƿڵ ǷֱΧ Լڵ֮Ĺϵ 
	public:
		node();
		void setleft(node *l) {//ͬʱϵ 
			left=l;
			l->father=this;
			l->isleft=true;
		}
		void setright(node *r) {
			right=r;
			r->father=this;
			r->isleft=false;
		}

		void setinbrac(bool b) {
			inbracket=b;
		}
		void setisroot(bool r) {
			isroot=r;
		}

		void setoper(char o) {
			isoper=true;
			oper=o;
		}
		void setnum(int n) {
			isoper=false;
			num=n;
		}

		bool getinbrac() {
			return inbracket;
		}
		bool getisroot() {
			return isroot;
		}
		bool getisoper() {
			return isoper;
		}
		bool getisleft() {
			return isleft;
		}

		char getoper() {
			return oper;
		}
		int getnum() {

			return num;
		}

		node* getfather() {
			return father;
		}
		node* getleft() {
			return left;
		}
		node* getright() {
			return right;
		}
		int getno(){
			return no;
		}
	private:
		bool inbracket,isroot,isoper,isleft;
		char oper;
		int num,no;
		node *father,*left,*right;
};

vector<node*> nodes;
//ڵĻ棬ڿͽڵ 
node::node(){
	inbracket=isroot=isoper=isleft=false;
	oper='+';
	num=0;
	no=nodes.size();
	father=left=right=NULL;
}

string str;
int pos;
//ʽ 
void end(){
	system("pause");
	exit(0);
}

void error(string str="") {
	if(str!="")
		cout<<str<<endl;
	cout<<"HSSCalc exit."<<endl;
	end();
}

bool cisnum(char c) {
//жϴַǷ 
	return c>='0'&&c<='9';
}

int getOperLevel(char c) {
//жϴַǷַ Լȼ 
	for(int i=0; i<row; i++) {
		for(int j=0; j<col; j++) {
			if(operTable[i][j]=='\0') {
				break;
			} else if(operTable[i][j]==c) {
				return i;
			}
		}
	}
	return INVALID;
}

bool cisoper(char c){
	//ַҲ ( )
	return getOperLevel(c)!=INVALID&&c!='('&&c!=')';
}

void check() {
	int cnt=0;
	if(str=="")//TODO  
		error("Empty string error.");
	for(int i=0; i<(signed int)str.length(); i++) {
		if(!cisnum(str[i])) {
			if(getOperLevel(str[i])==INVALID) {//Ȳ ֲַ 
				error("Invalid char error.");
			} else if(str[i]=='(') {//Ƕ׼ 
				cnt++;
			} else if(str[i]==')') {
				cnt--;
			}
		}
		if(cnt<0) {
			error("Invalid bracket error.");
		}
	}
	if(cnt!=0) {
		error("Invalid bracket error.");
	}
}

int getstage(node &n) {
//жϴ˽ڵ㴦ĸ׶ ѡȡʱҪδ 
	if(n.getleft()==NULL)
		return STGLEFT;//ûӽڵ 
	else if(!n.getisoper())
		return STGOPER;//ûв 
	else if(n.getright()==NULL)
		return STGRIGHT;//ûӽڵ
	else
		return STGENDING;//ڼǷ ) ҪȼĲ 
}

char nextchar() {
	if(pos>=(signed int)str.length()-1)
		return '\0';
	else
		return str[++pos];
}

int getStrNum() {
//ʽǰַַʱ õ 
	int num=0;
	while(pos<(signed int)str.length()&&cisnum(str[pos])) {
		num=num*10+str[pos]-'0';
		pos++;
	}
	pos--;
	return num;
}

int opcomp(char op1,char op2){
//ȼȽ жϽڵϵδ 
//ע Ҫop1 op2 
	int level1=getOperLevel(op1);
	int level2=getOperLevel(op2);
	
	if(level1==INVALID){
		ostringstream oss;
		oss<<"Compare error, pos "<<pos<<",oper "<<op1<<".";
		error(oss.str());
	}
	if(level2==INVALID){
		ostringstream oss;
		oss<<"Compare error, pos "<<pos<<",oper "<<op2<<".";
		error(oss.str());
	}
	
	if(level1<level2)
		return LOWER;
	else//ͬ 
		return HIGHER;
}

void output(int num){
	cout<<num<<endl;
}

node* newnode(){
//̬ 뻺 
	node *n=new node();
	nodes.push_back(n);
	return n;
}

void maketree(node &curr) {
//ͽڵ׶ ״̬ 
	char inp;
	node *addleft;
	node *addright;
	node *addcomp;
	switch(getstage(curr)) {
		case STGLEFT://ûڵʱ 
			addleft=newnode();
			inp=nextchar();
			if(cisnum(inp)) {// ڵ 
				addleft->setnum(getStrNum());
				curr.setleft(addleft);
			} else if(inp=='(') {//ڵ 
				addleft->setinbrac(true);
				curr.setleft(addleft);
				maketree(*addleft);
			} else {//error
				ostringstream oss;
				oss<<"236:Maketree error, pos "<<pos<<",Stage left.";
				error(oss.str());
			}
		case STGOPER://ûвʱ 
			inp=nextchar();
			if(cisoper(inp)){//ǲ ֵ 
				curr.setoper(inp);
			}else if(inp=='\0'){//ַ ΪǶ û ( ,ʽǵ 
				if(!curr.getleft()->getisoper()){//ʵǲ Ϊstage leftͱ 
					output(curr.getleft()->getnum());
					end();
				}else{//error
					ostringstream oss;
					oss<<"251:Maketree error, node "<<curr.getno()<<" pos "<<pos<<" stage oper,inp \\0.";
					error(oss.str());
				}
			}else{//error
				ostringstream oss;
				oss<<"256:Maketree error, node "<<curr.getno()<<" pos "<<pos<<" stage oper.";
				error(oss.str());
			}
		case STGRIGHT://ûҽڵʱ stage left 
			addright=newnode();
			inp=nextchar();

			if(cisnum(inp)) {
				addright->setnum(getStrNum());
				curr.setright(addright);
			} else if(inp=='(') {
				addright->setinbrac(true);
				curr.setright(addright);
				maketree(*addright);
			} else {
				ostringstream oss;
				oss<<"274:Maketree error, pos "<<pos<<",Stage right.";
				error(oss.str());
		}

		default://STGENDING ڼ ) ҪȼĲ 
			inp=nextchar();
			
			if(cisoper(inp)){//ǲ 
				
				addcomp=newnode();
				addcomp->setoper(inp);
				
				if(opcomp(curr.getoper(),inp)==HIGHER){//ǰڵȼȺĸ Ǻĵӽڵ 
					if(!curr.getisroot())
						if(curr.getisleft())//ϵת 
							curr.getfather()->setleft(addcomp);
						else
							curr.getfather()->setright(addcomp);
							
					addcomp->setinbrac(curr.getinbrac());//ǰڵΪӽڵ 
					curr.setinbrac(false);
					addcomp->setisroot(curr.getisroot());
					curr.setisroot(false);
					
					addcomp->setleft(&curr);

				}else{//ȼ ĸڵ 
					addcomp->setleft(curr.getright());//ҽڵ Ϊҽڵ 5+3*2 
					curr.setright(addcomp);
				}
				maketree(*addcomp);//봦תƸ ҽڵ 
			}else if(inp!=')'&&inp!='\0'){// ) ʱ Զؽ 
				ostringstream oss;
				oss<<"236:Maketree error, pos "<<pos<<",Stage ending.";
				error(oss.str());
			}
	}
}

node* uptoroot(node *n){//mainĳʼڵ õrootڵ ϶¼ 
	while(!n->getisroot()){
		n=n->getfather();
	}
	return n;
}

void deltree(){
	
	while(nodes.size()!=0){
		delete nodes.back();
		nodes.pop_back();
	}
}

int calc(node &n){
	if(!n.getisoper()) return n.getnum();// ֵǱ 
	switch(n.getoper()){//ݲƥ㷽 
		case '+':
			return calc(*n.getleft())+calc(*n.getright());
		break;
		case '-':
			return calc(*n.getleft())-calc(*n.getright());
		break;
		case '*':
			return calc(*n.getleft())*calc(*n.getright());
		break;
		case '/':
			return calc(*n.getleft())/calc(*n.getright());
		break;
	}//ƥ򱨴 
	ostringstream oss;
	oss<<"355:Calc error, node "<<n.getno()<<" oper "<<n.getoper();
	error(oss.str());
	return INVALID;
}

int main() {
	cout<<"Helix SStrict Calculator Beta"<<endl;
	
	cout<<"Input:"<<endl;//ʽ 
	cin>>str;
	pos=-1;

	check();//鴮 

	node *n=newnode();
	n->setisroot(true);//ڵ 

	maketree(*n);// 
	n=uptoroot(n);//ϵroot 
	output(calc(*n));//㲢 
	deltree();// ڴ 
	cout<<"HSSCalc exit."<<endl;
	system("pause");
	return 0;
}
